package org.pytorch.serve.grpc.inference;

import static io.grpc.MethodDescriptor.generateFullMethodName;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.45.1)",
    comments = "Source: inference.proto")
@io.grpc.stub.annotations.GrpcGenerated
public final class InferenceAPIsServiceGrpc {

  private InferenceAPIsServiceGrpc() {}

  public static final String SERVICE_NAME = "org.pytorch.serve.grpc.inference.InferenceAPIsService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      TorchServeHealthResponse> getPingMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "Ping",
      requestType = com.google.protobuf.Empty.class,
      responseType = TorchServeHealthResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.google.protobuf.Empty,
      TorchServeHealthResponse> getPingMethod() {
    io.grpc.MethodDescriptor<com.google.protobuf.Empty, TorchServeHealthResponse> getPingMethod;
    if ((getPingMethod = InferenceAPIsServiceGrpc.getPingMethod) == null) {
      synchronized (InferenceAPIsServiceGrpc.class) {
        if ((getPingMethod = InferenceAPIsServiceGrpc.getPingMethod) == null) {
          InferenceAPIsServiceGrpc.getPingMethod = getPingMethod =
              io.grpc.MethodDescriptor.<com.google.protobuf.Empty, TorchServeHealthResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "Ping"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.protobuf.Empty.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  TorchServeHealthResponse.getDefaultInstance()))
              .setSchemaDescriptor(new InferenceAPIsServiceMethodDescriptorSupplier("Ping"))
              .build();
        }
      }
    }
    return getPingMethod;
  }

  private static volatile io.grpc.MethodDescriptor<PredictionsRequest,
      PredictionResponse> getPredictionsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "Predictions",
      requestType = PredictionsRequest.class,
      responseType = PredictionResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<PredictionsRequest,
      PredictionResponse> getPredictionsMethod() {
    io.grpc.MethodDescriptor<PredictionsRequest, PredictionResponse> getPredictionsMethod;
    if ((getPredictionsMethod = InferenceAPIsServiceGrpc.getPredictionsMethod) == null) {
      synchronized (InferenceAPIsServiceGrpc.class) {
        if ((getPredictionsMethod = InferenceAPIsServiceGrpc.getPredictionsMethod) == null) {
          InferenceAPIsServiceGrpc.getPredictionsMethod = getPredictionsMethod =
              io.grpc.MethodDescriptor.<PredictionsRequest, PredictionResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "Predictions"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  PredictionsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  PredictionResponse.getDefaultInstance()))
              .setSchemaDescriptor(new InferenceAPIsServiceMethodDescriptorSupplier("Predictions"))
              .build();
        }
      }
    }
    return getPredictionsMethod;
  }

  private static volatile io.grpc.MethodDescriptor<PredictionsRequest,
      PredictionResponse> getStreamPredictionsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "StreamPredictions",
      requestType = PredictionsRequest.class,
      responseType = PredictionResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
  public static io.grpc.MethodDescriptor<PredictionsRequest,
      PredictionResponse> getStreamPredictionsMethod() {
    io.grpc.MethodDescriptor<PredictionsRequest, PredictionResponse> getStreamPredictionsMethod;
    if ((getStreamPredictionsMethod = InferenceAPIsServiceGrpc.getStreamPredictionsMethod) == null) {
      synchronized (InferenceAPIsServiceGrpc.class) {
        if ((getStreamPredictionsMethod = InferenceAPIsServiceGrpc.getStreamPredictionsMethod) == null) {
          InferenceAPIsServiceGrpc.getStreamPredictionsMethod = getStreamPredictionsMethod =
              io.grpc.MethodDescriptor.<PredictionsRequest, PredictionResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "StreamPredictions"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  PredictionsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  PredictionResponse.getDefaultInstance()))
              .setSchemaDescriptor(new InferenceAPIsServiceMethodDescriptorSupplier("StreamPredictions"))
              .build();
        }
      }
    }
    return getStreamPredictionsMethod;
  }

  private static volatile io.grpc.MethodDescriptor<PredictionsRequest,
      PredictionResponse> getStreamPredictions2Method;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "StreamPredictions2",
      requestType = PredictionsRequest.class,
      responseType = PredictionResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
  public static io.grpc.MethodDescriptor<PredictionsRequest,
      PredictionResponse> getStreamPredictions2Method() {
    io.grpc.MethodDescriptor<PredictionsRequest, PredictionResponse> getStreamPredictions2Method;
    if ((getStreamPredictions2Method = InferenceAPIsServiceGrpc.getStreamPredictions2Method) == null) {
      synchronized (InferenceAPIsServiceGrpc.class) {
        if ((getStreamPredictions2Method = InferenceAPIsServiceGrpc.getStreamPredictions2Method) == null) {
          InferenceAPIsServiceGrpc.getStreamPredictions2Method = getStreamPredictions2Method =
              io.grpc.MethodDescriptor.<PredictionsRequest, PredictionResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "StreamPredictions2"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  PredictionsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  PredictionResponse.getDefaultInstance()))
              .setSchemaDescriptor(new InferenceAPIsServiceMethodDescriptorSupplier("StreamPredictions2"))
              .build();
        }
      }
    }
    return getStreamPredictions2Method;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static InferenceAPIsServiceStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<InferenceAPIsServiceStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<InferenceAPIsServiceStub>() {
        @Override
        public InferenceAPIsServiceStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new InferenceAPIsServiceStub(channel, callOptions);
        }
      };
    return InferenceAPIsServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static InferenceAPIsServiceBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<InferenceAPIsServiceBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<InferenceAPIsServiceBlockingStub>() {
        @Override
        public InferenceAPIsServiceBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new InferenceAPIsServiceBlockingStub(channel, callOptions);
        }
      };
    return InferenceAPIsServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static InferenceAPIsServiceFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<InferenceAPIsServiceFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<InferenceAPIsServiceFutureStub>() {
        @Override
        public InferenceAPIsServiceFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new InferenceAPIsServiceFutureStub(channel, callOptions);
        }
      };
    return InferenceAPIsServiceFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class InferenceAPIsServiceImplBase implements io.grpc.BindableService {

    /**
     * <pre>
     * Check health status of the TorchServe server.
     * </pre>
     */
    public void ping(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<TorchServeHealthResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getPingMethod(), responseObserver);
    }

    /**
     * <pre>
     * Predictions entry point to get inference using default model version.
     * </pre>
     */
    public void predictions(PredictionsRequest request,
                            io.grpc.stub.StreamObserver<PredictionResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getPredictionsMethod(), responseObserver);
    }

    /**
     * <pre>
     * Streaming response for an inference request.
     * </pre>
     */
    public void streamPredictions(PredictionsRequest request,
                                  io.grpc.stub.StreamObserver<PredictionResponse> responseObserver) {
      io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall(getStreamPredictionsMethod(), responseObserver);
    }

    /**
     * <pre>
     * Bi-direction streaming inference and response.
     * </pre>
     */
    public io.grpc.stub.StreamObserver<PredictionsRequest> streamPredictions2(
        io.grpc.stub.StreamObserver<PredictionResponse> responseObserver) {
      return io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall(getStreamPredictions2Method(), responseObserver);
    }

    @Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getPingMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                com.google.protobuf.Empty,
                TorchServeHealthResponse>(
                  this, METHODID_PING)))
          .addMethod(
            getPredictionsMethod(),
            io.grpc.stub.ServerCalls.asyncUnaryCall(
              new MethodHandlers<
                PredictionsRequest,
                PredictionResponse>(
                  this, METHODID_PREDICTIONS)))
          .addMethod(
            getStreamPredictionsMethod(),
            io.grpc.stub.ServerCalls.asyncServerStreamingCall(
              new MethodHandlers<
                PredictionsRequest,
                PredictionResponse>(
                  this, METHODID_STREAM_PREDICTIONS)))
          .addMethod(
            getStreamPredictions2Method(),
            io.grpc.stub.ServerCalls.asyncBidiStreamingCall(
              new MethodHandlers<
                PredictionsRequest,
                PredictionResponse>(
                  this, METHODID_STREAM_PREDICTIONS2)))
          .build();
    }
  }

  /**
   */
  public static final class InferenceAPIsServiceStub extends io.grpc.stub.AbstractAsyncStub<InferenceAPIsServiceStub> {
    private InferenceAPIsServiceStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @Override
    protected InferenceAPIsServiceStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new InferenceAPIsServiceStub(channel, callOptions);
    }

    /**
     * <pre>
     * Check health status of the TorchServe server.
     * </pre>
     */
    public void ping(com.google.protobuf.Empty request,
        io.grpc.stub.StreamObserver<TorchServeHealthResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getPingMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Predictions entry point to get inference using default model version.
     * </pre>
     */
    public void predictions(PredictionsRequest request,
                            io.grpc.stub.StreamObserver<PredictionResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncUnaryCall(
          getChannel().newCall(getPredictionsMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Streaming response for an inference request.
     * </pre>
     */
    public void streamPredictions(PredictionsRequest request,
                                  io.grpc.stub.StreamObserver<PredictionResponse> responseObserver) {
      io.grpc.stub.ClientCalls.asyncServerStreamingCall(
          getChannel().newCall(getStreamPredictionsMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Bi-direction streaming inference and response.
     * </pre>
     */
    public io.grpc.stub.StreamObserver<PredictionsRequest> streamPredictions2(
        io.grpc.stub.StreamObserver<PredictionResponse> responseObserver) {
      return io.grpc.stub.ClientCalls.asyncBidiStreamingCall(
          getChannel().newCall(getStreamPredictions2Method(), getCallOptions()), responseObserver);
    }
  }

  /**
   */
  public static final class InferenceAPIsServiceBlockingStub extends io.grpc.stub.AbstractBlockingStub<InferenceAPIsServiceBlockingStub> {
    private InferenceAPIsServiceBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @Override
    protected InferenceAPIsServiceBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new InferenceAPIsServiceBlockingStub(channel, callOptions);
    }

    /**
     * <pre>
     * Check health status of the TorchServe server.
     * </pre>
     */
    public TorchServeHealthResponse ping(com.google.protobuf.Empty request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getPingMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Predictions entry point to get inference using default model version.
     * </pre>
     */
    public PredictionResponse predictions(PredictionsRequest request) {
      return io.grpc.stub.ClientCalls.blockingUnaryCall(
          getChannel(), getPredictionsMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Streaming response for an inference request.
     * </pre>
     */
    public java.util.Iterator<PredictionResponse> streamPredictions(
        PredictionsRequest request) {
      return io.grpc.stub.ClientCalls.blockingServerStreamingCall(
          getChannel(), getStreamPredictionsMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class InferenceAPIsServiceFutureStub extends io.grpc.stub.AbstractFutureStub<InferenceAPIsServiceFutureStub> {
    private InferenceAPIsServiceFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @Override
    protected InferenceAPIsServiceFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new InferenceAPIsServiceFutureStub(channel, callOptions);
    }

    /**
     * <pre>
     * Check health status of the TorchServe server.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<TorchServeHealthResponse> ping(
        com.google.protobuf.Empty request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getPingMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Predictions entry point to get inference using default model version.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<PredictionResponse> predictions(
        PredictionsRequest request) {
      return io.grpc.stub.ClientCalls.futureUnaryCall(
          getChannel().newCall(getPredictionsMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_PING = 0;
  private static final int METHODID_PREDICTIONS = 1;
  private static final int METHODID_STREAM_PREDICTIONS = 2;
  private static final int METHODID_STREAM_PREDICTIONS2 = 3;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final InferenceAPIsServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(InferenceAPIsServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @Override
    @SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_PING:
          serviceImpl.ping((com.google.protobuf.Empty) request,
              (io.grpc.stub.StreamObserver<TorchServeHealthResponse>) responseObserver);
          break;
        case METHODID_PREDICTIONS:
          serviceImpl.predictions((PredictionsRequest) request,
              (io.grpc.stub.StreamObserver<PredictionResponse>) responseObserver);
          break;
        case METHODID_STREAM_PREDICTIONS:
          serviceImpl.streamPredictions((PredictionsRequest) request,
              (io.grpc.stub.StreamObserver<PredictionResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @Override
    @SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_STREAM_PREDICTIONS2:
          return (io.grpc.stub.StreamObserver<Req>) serviceImpl.streamPredictions2(
              (io.grpc.stub.StreamObserver<PredictionResponse>) responseObserver);
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class InferenceAPIsServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    InferenceAPIsServiceBaseDescriptorSupplier() {}

    @Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return Inference.getDescriptor();
    }

    @Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("InferenceAPIsService");
    }
  }

  private static final class InferenceAPIsServiceFileDescriptorSupplier
      extends InferenceAPIsServiceBaseDescriptorSupplier {
    InferenceAPIsServiceFileDescriptorSupplier() {}
  }

  private static final class InferenceAPIsServiceMethodDescriptorSupplier
      extends InferenceAPIsServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    InferenceAPIsServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (InferenceAPIsServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new InferenceAPIsServiceFileDescriptorSupplier())
              .addMethod(getPingMethod())
              .addMethod(getPredictionsMethod())
              .addMethod(getStreamPredictionsMethod())
              .addMethod(getStreamPredictions2Method())
              .build();
        }
      }
    }
    return result;
  }
}
