package com.slibra.business.req;

import com.alibaba.fastjson2.annotation.JSONField;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;


@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class PolicyReq {

    @JSONField(name = "bot_id")
    private String botId = "b00001";

    @JSONField(name = "exp_id")
    private String expId = "721";

    @JSONField(name = "norm")
    private String norm;

    @JSONField(name = "feedback")
    private Map<String, Object> feedback;

    @JSONField(name = "simulate")
    private Map<String, Object> simulate;

    @JSONField(name = "session_id")
    private String sessionId;

    @JSONField(name = "generate_args")
    private GenerateArgs generateArgs = new GenerateArgs();

    @JSONField(name = "extra")
    private Map<String, Object> extra;

    //2024年7月3日16:18:48 新增参数
    @JSONField(name = "tools")
    private String tools = "true";
}
