package com.slibra.business.req;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;


@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class AiChatRes {

    //业务数据
    private Map<String, Object> data;

    //会话Id
    private String sessionId;

    //用户id
    private String userId;

    //节点id
    private String nodeId;

    //响应结果(0系统正常返回，其他系统异常信息)
    private String code = "0";


}
